$Shop::Client::Version = 6.2;

$Shop::Chars = "`~!@#^&*-=+{}\\|;:\'\",<>/?[].";
function ClientShop_getModPath(){return $Shop::Client::FilePath = "Add-Ons/Client_Shop/";}

$Shop::Client::FilePaths_Support = ClientShop_getModPath() @ "Support/";
$Shop::Client::FilePaths_Profiles = ClientShop_getModPath() @ "Profiles/";

function ClientShop_GetPath(%string)
{
	return $Shop::Client::FilePaths_[%string];
}

exec(ClientShop_GetPath("Support") @ "Support_ColorToRGB.cs");
exec(ClientShop_GetPath("Profiles") @ "Profiles.cs");
//exec(ClientShop_GetPath("Support") @ "Support_UpdaterDownload.cs"); //Nop
$Tango::Debug = false;

if(!isObject(ShopGui))
{
	exec("./ShopGui.gui");
	Shop_AnyoneCheck.setValue(1);
	Shop_AdminOnlyCheck.setValue(0);
	Shop_SuperAdminOnlyCheck.setValue(0);
}

if(isPackage(ClientShop_Client)) deactivatePackage(ClientShop_Client);

package ClientShop_Client
{
	function disconnectedCleanup()
	{
		deleteVariables("$Shop::Cache*");
		clientCmdShop("SET_AUTOLOADMODE", 0);
		clientCmdShop("CLEAR");
		clientCmdShop("SET_CATEGORIES");
		ClientShopGroup.categories = "";
		return Parent::disconnectedCleanup();
	}
};
activatePackage(ClientShop_Client);

if(!isObject(ClientShopGroup))
{
	new ScriptGroup(ClientShopGroup)
	{
		class = ClientShopSO;
	};
}

function getClientShopGroup()
{
	return nameToID(ClientShopGroup);
}

function findDatablockItemByName(%item, %val)
{
	if(isObject(%item))
		return %item.getName();

	if(!isObject(DatablockItemCache)) new ScriptObject(DatablockItemCache);
	if(DatablockItemCache.itemCount <= 0 || %val) //We don't need to cause lag everytime we try to find an item
	{
		DatablockItemCache.itemCount = 0;
		for(%i=0;%i<getDatablockGroupSize();%i++)
		{
			%obj = getDatablock(%i);

			if(%obj.getClassName() $= "ItemData" && strLen(%obj.uiName) > 0)
			{
				DatablockItemCache.item[DatablockItemCache.itemCount] = %obj;
				DatablockItemCache.itemCount++;
			}
		}
	}

	if(DatablockItemCache.itemCount > 0)
	{
		for(%a=0;%a<DatablockItemCache.itemCount;%a++)
		{
			%objA = DatablockItemCache.item[%a];
			if(%objA.getClassName() $= "ItemData")
				if(striPos(%objA.uiName, %item) == 0)
				{
					//talk("Found item, position detection: " @ striPos(%objA.uiName,%item));
					return %objA.getName();
				}
		}
	}
	return -1;
}

function ShopWindowEdit::Refresh(%this)
{
	$Client::ShopData["EditorItem"] = $Client::ShopData["Item"];

	Shop_ImageEdit.setBitmap("Add-Ons/Client_Shop/Images/Unknown");
	Shop_ImageEdit.setColor("1 1 1 1");
	Shop_PriceEdit.setValue("0");
	Shop_NameEdit.setValue("Unknown");
	Shop_CategoryEdit.setValue("Unknown");
	Shop_DescriptionEdit.setValue("Unknown");

	Shop_AdminLevelEdit.clear();
	Shop_AdminLevelEdit.add("Anyone", 0);
	Shop_AdminLevelEdit.add("Admin", 1);
	Shop_AdminLevelEdit.add("Super admin", 2);
	Shop_AdminLevelEdit.setSelected(0);

	Shop_CanSaveEdit.setValue(0);
	Shop_BuyOnceEdit.setValue(0);

	if(isObject(%obj = $Client::ShopData["Item"]))
	{
		if(!strLen(%image))
		{
			if(!strLen(%obj.icon))
				%image = "Add-Ons/Client_Shop/Images/Unknown";	
			else
				%image = %obj.icon;
		}

		Shop_ImageEdit.setBitmap(%image);
		Shop_ImageEdit.setColor(%obj.iconColor);
		Shop_NameEdit.setValue(%obj.uiName);
		Shop_PriceEdit.setValue(%obj.cost);
		Shop_CategoryEdit.setValue(%obj.shopClass);
		Shop_DescriptionEdit.setValue(%obj.description);

		Shop_AdminLevelEdit.setSelected(%obj.adminLevel);

		Shop_CanSaveEdit.setValue(%obj.canSave);
		Shop_BuyOnceEdit.setValue(%obj.buyOnce);
	}
	else
		$Client::ShopData["EditorItem"] = -1;
}

function ShopGui::onWake(%this)
{
	if(!isObject(ServerConnection))
		return; //We might be in an editor.

	Shop_AdminModeButton.setVisible($IAmAdmin >= 2);
	Shop_ShopModeButton.setVisible($IAmAdmin >= 2);

	//We will only lag the gui once
	if(isObject(ServerConnection.getControlObject()) && ServerConnection.lastDatablockGroupSize != getDatablockGroupSize())
	{
		ServerConnection.lastDatablockGroupSize = getDatablockGroupSize();
		Shop_AdminList.clear();

		for(%i = 0; %i < getDatablockGroupSize(); %i++)
		{
			%data = getDatablock(%i);
			if(%data.uiName !$= "" && %data.getClassName() $= "ItemData")
				Shop_AdminList.addRow(Shop_AdminList.rowCount(), %data.uiName);
		}
		Shop_AdminList.sort(0);

		if(Shop_APopUp.isActive())
		{
			%text = Shop_APopUp.getText();
			Shop_APopUp.clear();
			for(%i = 0; %i < getFieldCount(getClientShopGroup().categories); %i++)
			{
				%field = getField(getClientShopGroup().categories, %i);
				Shop_APopUp.add(%field, Shop_APopUp.getCount());
			}
			Shop_APopUp.setText(%text);
		}
	}
}

function ClientShopSO::findScript(%this, %ShopName)
{
	//Agh got to make everything complicated
	for(%i=0;%i<%this.getCount();%i++)
	{
		%obj = %this.getObject(%i);
		if(nameToID(%ShopName) == nameToID(%obj))
			return %obj;
	}

	for(%i=0;%i<%this.getCount();%i++)
	{
		%obj = %this.getObject(%i);
		if(%obj.uiName $= %ShopName)
			return %obj;
	}

	for(%i=0;%i<%this.getCount();%i++)
	{
		%obj = %this.getObject(%i);
		if(striPos(%obj.uiName, %ShopName) == 0)
			return %obj;
	}
	return -1;
}

function ClientShopItem::onAdd(%this)
{
	getClientShopGroup().add(%this);
}

function ClientShopSO::setAdminInfo(%this, %class)
{
	if(!isObject(%group = getClientShopGroup()))
		return;

	if(!isObject(%datablock = findDatablockItemByName(%class)))
		return;

	%className = %datablock.uiName;
	Shop_AdminName.setText("<just:center>" @ %className);
	%shop["cost"] = 0;
	%shop["description"] = "aaaa";

	%shop["name"] = %datablock.uiName;

	if(isObject(%classObj = getClientShopGroup().findScript(%class)))
	{
		%shop["cost"] = %classObj.cost;
		%shop["description"] = %classObj.description;
		%shop["damage"] = %classObj.damage;
		%shop["radius"] = %classObj.radiusDamage;
		Shop_AddButton.setColor("1 1 0 1");
		Shop_AddButton.setActive(false);
		Shop_AddButton.setText("Cannot Add");
	}
	else
	{
		Shop_AddButton.setColor("1 1 1 1");
		Shop_AddButton.setActive(true);
		Shop_AddButton.setText("Add Item");
	}

	Shop_AdminPricePtsEditor.setValue(mFloor(%shop["cost"]));
	%len = strLen(strReplace(%shop["cost"],"0","1")-1);
   	%stuffs = 5 + (5.85 * %len);

	Shop_AdminPricePtsEditor.tangoScaleTo(%stuffs @ " 18", 400, "expo");

	Shop_AdminName.setText("<just:center>" @ %shop["name"]);
	Shop_AdminPricePts.setText(%shop["cost"]);
	Shop_AdminDescriptionEdit.setValue(%shop["description"]);

	$Shop::CurrentAdminInfo = %shop["name"];
	Shop_AddButton.setVisible(1);
}

function ClientShopSO::setInfo(%this, %class)
{
	if(!isObject(%group = getClientShopGroup()))
		return;

	if(!isObject(%classObj = %group.findScript(%class)))
		return;

	%no = 1;
	$Client::ShopData["Item"] = %classObj;
	%className = %classObj.uiName;
	Shop_Name.setText("<just:center>" @ %className);

	if(isObject(%classObj))
	{
		%no = 0;
		%shop["cannotModify"] = %classObj.cannotModify;
		if(!strLen(%shop["image"]))
		{
			if(!strLen(%classObj.icon))
				%shop["image"] = "Add-Ons/Client_Shop/Images/Unknown";	
			else
				%shop["image"] = %classObj.icon;
		}

		%shop["name"] = %classObj.uiName;
		%shop["cost"] = %classObj.cost;
		%shop["itemcolor"] = %classObj.iconColor;
		%shop["damage"] = %classObj.directDamage;
		%shop["radius"] = %classObj.radiusDamage;
		%shop["description"] = %classObj.description;
		%shop["isBought"] = %classObj.isBought;
		Shop_Image.setVisible(true);
		Shop_Name.setVisible(true);
		Shop_PricePts.setVisible(true);
		Shop_PriceImage.setVisible(true);
		Shop_DamagePts.setVisible(true);
		Shop_rDamagePts.setVisible(true);
		Shop_Description.setVisible(true);
	}
	else
		Shop_Main("CLEAR_INFO");

	if(!%no)
	{
		Shop_EditButton.setVisible($IAmAdmin >= 2 && !%shop["cannotModify"]);
		Shop_DeleteButton.setVisible($IAmAdmin >= 2 && !%shop["cannotModify"]);
	}

	if(%shop["cost"] <= 0 && !%no && !strLen(%space)) %shop["cost"] = "FREE"; else if(!%no) %shop["cost"] = %shop["cost"] @ %space @ " Pts";
	if(%shop["damage"] < 0 && !%no) %shop["damage"] = "Unavailable"; else if(!%no) %shop["damage"] = %shop["damage"] @ " HP";
	if(%shop["radius"] < 0 && !%no) %shop["radius"] = "Unavailable"; else if(!%no) %shop["radius"] = %shop["radius"] @ " HP";

	Shop_Image.setBitmap(%shop["image"]);
	Shop_Image.setColor(%shop["itemcolor"]);
	Shop_Name.setText("<just:center>" @ %shop["name"]);
	Shop_PricePts.setText(%shop["cost"]);
	Shop_DamagePts.setText(%shop["damage"]);
	Shop_rDamagePts.setText(%shop["radius"]);
	Shop_Description.setText(%shop["description"]);

	Shop_DamagePts.setVisible(%shop["damage"] > 0);
	Shop_rDamagePts.setVisible(%shop["radius"] > 0);
	Shop_DamageImg.setVisible(%shop["damage"] > 0);
	Shop_rDamageImg.setVisible(%shop["radius"] > 0);

	$Shop::CurrentInfo = %shop["name"];
	Shop_BuyButton.setVisible(1);

	if(%shop["isBought"])
	{
		Shop_BuyButton.setColor("0.6 0.8 1 0.8");
		Shop_BuyButton.setText("Equip");
	}
	else
	{
		Shop_BuyButton.setColor("1 1 1 1");
		if($Shop::Cache::Points < %shop["cost"])
			Shop_BuyButton.setColor("1 0.6 0.6 0.8");
		Shop_BuyButton.setText("Buy");
		if($IAmAdmin < %shop["adminLevel"])
			Shop_BuyButton.setVisible(0);
	}
}

function Shop_Main(%option, %cmd1, %cmd2)
{
	switch$(%option)
	{
		case "ADD":
			commandToServer('Shop', "ADD", Shop_AdminList.getRowTextByID(Shop_AdminList.getSelectedID()), 
				Shop_AdminCategoryEditor.getValue(),
				Shop_AdminPricePtsEditor.getValue(),  
				Shop_AdminDescriptionEdit.getValue(),
				Shop_AdminKeepCheck.getValue() SPC 
					Shop_AdminOnlyCheck.getValue() SPC Shop_SuperAdminOnlyCheck.getValue() 
					SPC Shop_AdminItemEditor.getValue() SPC 
					Shop_AdminSaveCheck.getValue());

		case "BUY":
			if(!isObject(%group = getClientShopGroup()))
				return;

			commandToServer('Shop', "BUY", Shop_List.getRowTextByID(Shop_List.getSelectedID()));

		case "DELETE":
			if(!isObject(%group = getClientShopGroup()))
				return;

			commandToServer('Shop', "DELETE", Shop_List.getRowTextByID(Shop_List.getSelectedID()));

		case "EDIT":
			ShopWindowEdit.setVisible(0); //Refresh
			ShopWindowEdit.setVisible(1);
			ShopGui.pushToBack(ShopWindowEdit);
			ShopWindowEdit.Refresh();

		case "EDITDONE":
			ShopWindowEdit.setVisible(0);
			commandToServer('Shop', "EDIT", Shop_List.getRowTextByID(Shop_List.getSelectedID()), 
				Shop_PriceEdit.getValue(), 
				Shop_DescriptionEdit.getValue(),
				Shop_CategoryEdit.getValue(),
				Shop_CanSaveEdit.getValue() TAB Shop_BuyOnceEdit.getValue() TAB Shop_AdminLevelEdit.getSelected());

		case "MODE":
			if(!isObject(%group = getClientShopGroup()))
				return;

			Shop_List.clear();
			for(%i = 0; %i < %group.getCount(); %i++)
			{
				%obj = %group.getObject(%i);
				if(%obj.shopClass $= Shop_APopUp.getText())
					Shop_List.addRow(%obj.ShopID, %obj.uiName);
			}

			Shop_List.sort(0, 1);

		case "MAINMODE":
			if(!isObject(%group = getClientShopGroup()))
				return;

			ItemAddSwatch.setVisible(false);
			ShopSwatch.setVisible(false);
			Shop_APopUp.setActive(false);
			Shop_APopUp.clear();

			switch$(%cmd1)
			{
				case "ADMIN":
					//Feel free to add anything else.
					Shop_APopUp.setText("Menu");
					ItemAddSwatch.setVisible(true);

				default:
					for(%i = 0; %i < getFieldCount(%group.categories); %i++)
					{
						%field = getField(%group.categories, %i);
						Shop_APopUp.add(%field, Shop_APopUp.getCount());
					}

					Shop_APopUp.setText("None");
					Shop_APopUp.setActive(true);
					ShopSwatch.setVisible(true);
			}

			Shop_APopUp.sort();

		case "CLEAR_INFO":
			$Client::ShopData["Item"] = -1;
			Shop_Image.setVisible(0);
			Shop_Name.setVisible(0);
			Shop_PricePts.setVisible(0);
			Shop_PriceImage.setVisible(0);
			Shop_Description.setVisible(0);
			Shop_DamagePts.setVisible(0);
			Shop_rDamagePts.setVisible(0);
			Shop_DamageImg.setVisible(0);
			Shop_rDamageImg.setVisible(0);

			$Shop::CurrentInfo = "None";
			Shop_BuyButton.setVisible(0);
			Shop_EditButton.setVisible(0);
			Shop_DeleteButton.setVisible(0);

		case "SELECT":
			if(!isObject(%group = getClientShopGroup()))
				return;

			switch$(%cmd1)
			{
				case "ADMIN":
					%group.setAdminInfo(Shop_AdminList.getRowTextByID(Shop_AdminList.getSelectedID()));

				default:
					%group.setInfo(Shop_List.getRowTextByID(Shop_List.getSelectedID()));
			}

		case "ESC":
			if(ShopWindowEdit.isVisible())
				ShopWindowEdit.setVisible(0);
			else
				canvas.popDialog(ShopGui);

		default: 
			NewChatHud_AddLine("[Shop client] - Invalid option : " @ %option);
	}
}

function ShopWindow::setLoading(%isVisible)
{
	Shop_MessageBlock.setVisible(%isVisible);
	Shop_Message.setVisible(%isVisible);
	Shop_MessageLoader.setVisible(%isVisible);

	%visible = (Shop_MessageLoader.isVisible() ? false : true);
	Shop_MessageOk.setVisible(%visible);
	Shop_MessageYesNo.setVisible(%visible);
}

function clientCmdShop_MessageBoxOk(%title,%msg)
{
	Shop_messageBoxOk(%title,%msg);
}

function Shop_messageBoxOk(%title,%msg)
{
	Shop_MessageBlock.setVisible(1);
	Shop_Message.setVisible(1);
	Shop_MessageYesNo.setVisible(0);
	Shop_MessageOk.setVisible(1);
	Shop_MessageOk.setText(%title);
	Shop_MessageOkText.setText("<just:center>" @ %msg);
}

function clientCmdShop_MessageBoxYesNo(%title,%msg,%yesCommand,%noCommand)
{
	Shop_messageBoxYesNo(%title, %msg, %yesCommand, %noCommand);
}

function Shop_messageBoxYesNo(%title,%msg,%yesCommand,%noCommand)
{
	Shop_MessageBlock.setVisible(1);
	Shop_Message.setVisible(1);
	Shop_MessageYesNo.setVisible(1);
	Shop_MessageOk.setVisible(0);
	Shop_MessageYesNo.setText(%title);
	Shop_MessageYesNoText.setText("<just:center>" @ %msg);
	$Shop::Cache::YesCommand = %yesCommand;
	$Shop::Cache::NoCommand = %noCommand;
}

function Shop_Refresh(){}

function Shop_Prompt(%wat)
{
	Shop_MessageBlock.setVisible(0);
	if(%wat $= "Yes")
		commandToServer($Shop::Cache::YesCommand);
	else if(%wat $= "No")
		commandToServer($Shop::Cache::NoCommand);
}

//Both sides will have less lag when loading the GUI
function clientCmdShop(%option, %cmd1, %cmd2, %cmd3, %cmd4, %cmd5, %cmd6, %cmd7, %cmd8)
{
	switch$(%option)
	{
		case "OPEN":
			if(!ShopGui.isAwake())
			{
				ShopWindowEdit.setVisible(0); //Refresh
				canvas.pushDialog(ShopGui);
			}

		case "HANDSHAKE":
			commandToServer('Shop', "HANDSHAKE", $Shop::Client::Version, %cmd1);

		case "SET_CATEGORIES": //Set category list
			getClientShopGroup().categories = %cmd1;
			if(Shop_APopUp.isActive())
			{
				%text = Shop_APopUp.getText();
				Shop_APopUp.clear();
				for(%i = 0; %i < getFieldCount(getClientShopGroup().categories); %i++)
				{
					%field = getField(getClientShopGroup().categories, %i);
					Shop_APopUp.add(%field, Shop_APopUp.getCount());
				}
				Shop_APopUp.setText(%text);
			}

		case "ADD": //Add a shop item
			%strName = stripChars(getField(%cmd1, 0), $Shop::Chars);
			%strName = strReplace(%strName, " ", "_");
			%objName = "ClientShop_" @ %strName;

			if(isObject(%objName))
			{
				warn("Warning: ClientShopItem data \"" @ %objName @ "\" already exists. Overwriting.");
				%objName.delete();
			}

			%obj = new ScriptObject(%objName)
			{
				class = "ClientShopItem";
				uiName = getField(%cmd1, 0);
				shopClass = getField(%cmd1, 1); //The client will see if it is a weapon, or a player upgrade, or whatever.
				cost = %cmd2;
				description = %cmd3;
				directDamage = getField(%cmd4, 0);
				radiusDamage = getField(%cmd4, 1);
				icon = getField(%cmd5, 0);
				iconColor = getField(%cmd5, 1);
				isBought = getField(%cmd6, 0);
				buyOnce = getField(%cmd6, 1);
				adminLevel = getField(%cmd7, 0);
				canSave = getField(%cmd7, 1);
				cannotModify = getField(%cmd7, 2);
				shopClass = getField(%cmd7, 3);
				ShopID = %cmd8;
			};

			if(ShopWindowEdit.isAwake())
				ShopWindowEdit.Refresh();

			if(ShopWindow.isAwake())
			{
				%old = $Client::ShopData["Item"];
				Shop_Main("CLEAR_INFO");
				$Client::ShopData["Item"] = %old;
			}

		case "SET_POINTS":
			$Shop::Cache::Points = %cmd1;
			ShopWindow.setText("Shop Menu - " @ mFloor(%cmd1) @ " Point(s)");

		case "SET_AUTOLOADMODE":
			if(%cmd1)
				Shop_AutoLoadButton.setText("UnAutoLoad");
			else
				Shop_AutoLoadButton.setText("AutoLoad");

		case "CLEAR":
			Shop_Main("CLEAR_INFO");
			Shop_APopUp.setSelected(-1);
			Shop_APopUp.setText("Category");
			Shop_List.clear();
			Shop_List.setSelected(-1);
			getClientShopGroup().deleteAll();

		default:
			//Nono
	}
}

function GuiTextEditCtrl::Shop_ValidateInt(%this, %option)
{
	if(!isObject(%this)) return;
	if(%this.getClassName() !$= "GuiTextEditCtrl") return;
   	if(%this.getValue() $= "") return;
   	if(%this.getValue() $= "-") return;

   	%value = mFloatLength(%this.getValue(), 0);

   	if(!strLen(%this.fieldMax)) %this.fieldMax = 1;
   	if(!strLen(%this.fieldMin)) %this.fieldMin = 0;

   	if(%value > %this.fieldMax) %value = %this.fieldMax;
   	if(%value < %this.fieldMin) %value = %this.fieldMin;

   	%this.setValue(%value);
   	%newValue = %this.getValue();
   	if(!%option)
   	{
   		Shop_PricePts.setText(%newValue @ "  Pts");
	   	%len = strLen(strReplace(%newValue, "0", "1")-1);
	   	%stuffs = 5 + (5.85 * %len);
		%this.tangoScaleTo(%stuffs @ " 18", 400, "expo");
	}
}